"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ramda = require("ramda");

var _execAsync = require("../../util/exec-async");

var _containerImage = require("../../domain/container-image");

const getAuthenticationForRegistry = async registry => {
  try {
    const credentialStore = registry === _containerImage.DEFAULT_REGISTRY ? _containerImage.DEFAULT_REGISTRY_AUTH : registry;
    const options = [credentialStore, '|', 'docker-credential-desktop', 'get'];
    const stdout = await (0, _execAsync.execAsync)('echo', options, _ramda.always, {
      cwd: process.cwd()
    });
    const credentials = JSON.parse(stdout);
    return {
      username: credentials['Username'],
      password: credentials['Secret']
    };
  } catch (exception) {
    return {
      username: '',
      password: ''
    };
  }
};

var _default = getAuthenticationForRegistry;
exports.default = _default;
module.exports = exports.default;