"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getEndpoint = _interopRequireDefault(require("./get-endpoint"));

var _ociApiSpecification = require("../../domain/oci-api-specification");

const getFatManifest = async ({
  allowUnauthorizedRequest = false,
  repository,
  registry,
  tag
}) => {
  const endpoint = _ociApiSpecification.restSpecification.getManifest(repository, tag);

  const options = {
    headers: {
      'Accept': _ociApiSpecification.MEDIA_TYPES.FAT_MANIFEST
    }
  };
  const response = await (0, _getEndpoint.default)({
    allowUnauthorizedRequest,
    endpoint,
    registry,
    options
  });
  return {
    tag: response.headers.get('docker-content-digest'),
    data: await response.json()
  };
};

var _default = getFatManifest;
exports.default = _default;
module.exports = exports.default;