"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _dockerClient = _interopRequireDefault(require("./docker-client"));

var _getFatManifest = _interopRequireDefault(require("../client/registry/get-fat-manifest"));

var _containerImage = require("../domain/container-image");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const hasUpdate = async (imageWithTag, currentImageId, navyFile) => {
  const tag = (0, _containerImage.getTagFromImageWithTag)(imageWithTag);
  const image = (0, _containerImage.getImageFromImageWithTag)(imageWithTag);
  const registry = (0, _containerImage.getRegistryFromImage)(image);
  const repository = (0, _containerImage.getRepositoryFromImage)(image);
  const allowUnauthorizedRequest = R.includes(registry, R.path(['ignoreUnauthorizedRequestsForRegistries'], navyFile));

  try {
    const {
      RepoDigests
    } = await _dockerClient.default.getImage(currentImageId).inspect();
    const manifest = await (0, _getFatManifest.default)({
      allowUnauthorizedRequest,
      repository,
      registry,
      tag
    });
    const remoteRepoDigest = `${image}@${manifest.tag}`;
    return !R.includes(remoteRepoDigest, RepoDigests);
  } catch {
    return 'INVALID_REMOTE';
  }
};

var _default = hasUpdate;
exports.default = _default;
module.exports = exports.default;